From e7d662d51d470caf9e54a1f55240ea81b7326de4 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 13 2020 00:38:22 +0000
Subject: [PATCH 1714/2232] Free Box allocation on T constructor exception


---

diff --git a/include/cxx.h b/include/cxx.h
index 52136cc..956c46e 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -553,6 +553,12 @@ class Box<T>::uninit {};
 template <typename T>
 class Box<T>::allocation {
 public:
+  allocation() noexcept : ptr(alloc()) {}
+  ~allocation() noexcept {
+    if (this->ptr) {
+      dealloc(this->ptr);
+    }
+  }
   static T *alloc() noexcept;
   static void dealloc(T *) noexcept;
   T *ptr;
@@ -567,13 +573,19 @@ Box<T>::Box(Box &&other) noexcept : ptr(other.ptr) {
 }
 
 template <typename T>
-Box<T>::Box(const T &val) : ptr(allocation::alloc()) {
-  ::new (this->ptr) T(val);
+Box<T>::Box(const T &val) {
+  allocation alloc;
+  ::new (alloc.ptr) T(val);
+  this->ptr = alloc.ptr;
+  alloc.ptr = nullptr;
 }
 
 template <typename T>
-Box<T>::Box(T &&val) : ptr(allocation::alloc()) {
-  ::new (this->ptr) T(std::move(val));
+Box<T>::Box(T &&val) {
+  allocation alloc;
+  ::new (alloc.ptr) T(std::move(val));
+  this->ptr = alloc.ptr;
+  alloc.ptr = nullptr;
 }
 
 template <typename T>
@@ -589,8 +601,10 @@ Box<T> &Box<T>::operator=(const Box &other) {
     if (this->ptr) {
       **this = *other;
     } else {
-      this->ptr = allocation::alloc();
-      ::new (this->ptr) T(*other);
+      allocation alloc;
+      ::new (alloc.ptr) T(*other);
+      this->ptr = alloc.ptr;
+      alloc.ptr = nullptr;
     }
   }
   return *this;
@@ -629,8 +643,11 @@ T &Box<T>::operator*() noexcept {
 template <typename T>
 template <typename... Fields>
 Box<T> Box<T>::in_place(Fields &&... fields) {
-  return from_raw(::new (allocation::alloc())
-                      T{std::forward<Fields>(fields)...});
+  allocation alloc;
+  auto ptr = alloc.ptr;
+  ::new (ptr) T{std::forward<Fields>(fields)...};
+  alloc.ptr = nullptr;
+  return from_raw(ptr);
 }
 
 template <typename T>

